/***************************************************************************
 * This file is part of the project AqFoxExt.                              *
 * AqFoxExt (c) by 2011 Martin Preuss, all rights reserved.                *
 *                                                                         *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FXXTEXTTABLE_HPP
#define FXXTEXTTABLE_HPP


#include <aqfoxext/aqfoxext.h>
#include <aqfoxext/fxx_table.hpp>

#include <fx.h>

#include <list>



class AQFOXEXT_API FXXTextTable: public FXXTable {
public:
  FXXTextTable(FXComposite *p, FXObject* tgt=NULL, FXSelector sel=0, FXuint opts=0,
               FXint x=0, FXint y=0, FXint w=0, FXint h=0,
               FXint pl=DEFAULT_MARGIN, FXint pr=DEFAULT_MARGIN,
               FXint pt=DEFAULT_MARGIN, FXint pb=DEFAULT_MARGIN);

  virtual ~FXXTextTable();


  const FXString &getText(int r, int c);
  void setText(int r, int c, const FXString &s);

  virtual void setNumberOfRows(int i);
  virtual void addColumn(const FXString &s, int size=DEFAULT_COLUMN_WIDTH);

protected:
  FXXTextTable();

  virtual ColumnInfo *getColumnInfo(int r, int c);
  virtual void releaseColumnInfo(ColumnInfo *ci);

  virtual FXWindow *getEditor(int r, int c);
  virtual void setFromEditor(ColumnInfo *ci, FXWindow *ed);
  virtual void releaseEditor(int r, int c, FXWindow *ed);

  FXString *m_strings;
  FXString m_emptyString;
};



#endif
